commit 2a4dbf933748d74d6a76cf48c9b106821ad8c0ff
Author: Thomas Schöpping <tschoepp@cit-ec.uni-bielefeld.de>
Date:   Fri Feb 8 10:08:20 2019 +0100

    Modified all unit tests (.c files) so the headers will included in any case.
    This is not necessary for compilation but for the QtCreator project setup to work properly.

diff --git a/unittests/lld/src/ut_lld_adc.c b/unittests/lld/src/ut_lld_adc.c
index 1b8134b..68c20f9 100644
--- a/unittests/lld/src/ut_lld_adc.c
+++ b/unittests/lld/src/ut_lld_adc.c
@@ -17,11 +17,10 @@ along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
 
 #include <amiroos.h>
+#include <ut_lld_adc.h>
 
 #if ((AMIROOS_CFG_TESTS_ENABLE == true) && (HAL_USE_ADC == TRUE))|| defined(__DOXYGEN__)
 
-#include <ut_lld_adc.h>
-
 /******************************************************************************/
 /* LOCAL DEFINITIONS                                                          */
 /******************************************************************************/
diff --git a/unittests/periphery-lld/src/ut_alld_A3906_v1.c b/unittests/periphery-lld/src/ut_alld_A3906_v1.c
index 2571b74..8bc308f 100644
--- a/unittests/periphery-lld/src/ut_alld_A3906_v1.c
+++ b/unittests/periphery-lld/src/ut_alld_A3906_v1.c
@@ -17,10 +17,10 @@ along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
 
 #include <amiroos.h>
+#include <ut_alld_A3906_v1.h>
 
 #if ((AMIROOS_CFG_TESTS_ENABLE == true) && defined(AMIROLLD_CFG_A3906) && (AMIROLLD_CFG_A3906 == 1)) || defined(__DOXYGEN__)
 
-#include <ut_alld_A3906_v1.h>
 #include <stdlib.h>
 #include <math.h>
 
diff --git a/unittests/periphery-lld/src/ut_alld_AT24C01B_v1.c b/unittests/periphery-lld/src/ut_alld_AT24C01B_v1.c
index eddcdbb..0e94197 100644
--- a/unittests/periphery-lld/src/ut_alld_AT24C01B_v1.c
+++ b/unittests/periphery-lld/src/ut_alld_AT24C01B_v1.c
@@ -17,11 +17,10 @@ along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
 
 #include <amiroos.h>
+#include <ut_alld_AT24C01B_v1.h>
 
 #if ((AMIROOS_CFG_TESTS_ENABLE == true) && defined(AMIROLLD_CFG_AT24C01B) && (AMIROLLD_CFG_AT24C01B == 1)) || defined(__DOXYGEN__)
 
-#include <ut_alld_AT24C01B_v1.h>
-
 /******************************************************************************/
 /* LOCAL DEFINITIONS                                                          */
 /******************************************************************************/
diff --git a/unittests/periphery-lld/src/ut_alld_AT42QT1050_v1.c b/unittests/periphery-lld/src/ut_alld_AT42QT1050_v1.c
index 0ddad2b..57129b2 100644
--- a/unittests/periphery-lld/src/ut_alld_AT42QT1050_v1.c
+++ b/unittests/periphery-lld/src/ut_alld_AT42QT1050_v1.c
@@ -17,11 +17,10 @@ along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
 
 #include <amiroos.h>
+#include <ut_alld_AT42QT1050_v1.h>
 
 #if ((AMIROOS_CFG_TESTS_ENABLE == true) && defined(AMIROLLD_CFG_AT42QT1050) && (AMIROLLD_CFG_AT42QT1050 == 1)) || defined(__DOXYGEN__)
 
-#include <ut_alld_AT42QT1050_v1.h>
-
 /******************************************************************************/
 /* LOCAL DEFINITIONS                                                          */
 /******************************************************************************/
diff --git a/unittests/periphery-lld/src/ut_alld_DW1000_v0.c b/unittests/periphery-lld/src/ut_alld_DW1000_v0.c
index 7be1955..9a98f78 100755
--- a/unittests/periphery-lld/src/ut_alld_DW1000_v0.c
+++ b/unittests/periphery-lld/src/ut_alld_DW1000_v0.c
@@ -17,11 +17,10 @@ along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
 
 #include <amiroos.h>
+#include <ut_alld_DW1000_v0.h>
 
 #if ((AMIROOS_CFG_TESTS_ENABLE == true) && defined(AMIROLLD_CFG_DW1000) && (AMIROLLD_CFG_DW1000 == 0)) || defined(__DOXYGEN__)
 
-#include <ut_alld_dw1000.h>
-
 /******************************************************************************/
 /* LOCAL DEFINITIONS                                                          */
 /******************************************************************************/
diff --git a/unittests/periphery-lld/src/ut_alld_HMC5883L_v1.c b/unittests/periphery-lld/src/ut_alld_HMC5883L_v1.c
index 4e55beb..8b06fa4 100644
--- a/unittests/periphery-lld/src/ut_alld_HMC5883L_v1.c
+++ b/unittests/periphery-lld/src/ut_alld_HMC5883L_v1.c
@@ -17,11 +17,10 @@ along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
 
 #include <amiroos.h>
+#include <ut_alld_HMC5883L_v1.h>
 
 #if ((AMIROOS_CFG_TESTS_ENABLE == true) && defined(AMIROLLD_CFG_HMC5883L) && (AMIROLLD_CFG_HMC5883L == 1)) || defined(__DOXYGEN__)
 
-#include <ut_alld_HMC5883L_v1.h>
-
 /******************************************************************************/
 /* LOCAL DEFINITIONS                                                          */
 /******************************************************************************/
diff --git a/unittests/periphery-lld/src/ut_alld_INA219_v1.c b/unittests/periphery-lld/src/ut_alld_INA219_v1.c
index aa1885c..de481f9 100644
--- a/unittests/periphery-lld/src/ut_alld_INA219_v1.c
+++ b/unittests/periphery-lld/src/ut_alld_INA219_v1.c
@@ -17,10 +17,10 @@ along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
 
 #include <amiroos.h>
+#include <ut_alld_INA219_v1.h>
 
 #if ((AMIROOS_CFG_TESTS_ENABLE == true) && defined(AMIROLLD_CFG_INA219) && (AMIROLLD_CFG_INA219 == 1)) || defined(__DOXYGEN__)
 
-#include <ut_alld_INA219_v1.h>
 #include <math.h>
 
 /******************************************************************************/
diff --git a/unittests/periphery-lld/src/ut_alld_L3G4200D_v1.c b/unittests/periphery-lld/src/ut_alld_L3G4200D_v1.c
index cd216f2..8b13602 100644
--- a/unittests/periphery-lld/src/ut_alld_L3G4200D_v1.c
+++ b/unittests/periphery-lld/src/ut_alld_L3G4200D_v1.c
@@ -17,11 +17,10 @@ along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
 
 #include <amiroos.h>
+#include <ut_alld_L3G4200D_v1.h>
 
 #if ((AMIROOS_CFG_TESTS_ENABLE == true) && defined(AMIROLLD_CFG_L3G4200D) && (AMIROLLD_CFG_L3G4200D == 1)) || defined(__DOXYGEN__)
 
-#include <ut_alld_L3G4200D_v1.h>
-
 /******************************************************************************/
 /* LOCAL DEFINITIONS                                                          */
 /******************************************************************************/
diff --git a/unittests/periphery-lld/src/ut_alld_LED_v1.c b/unittests/periphery-lld/src/ut_alld_LED_v1.c
index b014c6b..86daeb6 100644
--- a/unittests/periphery-lld/src/ut_alld_LED_v1.c
+++ b/unittests/periphery-lld/src/ut_alld_LED_v1.c
@@ -17,11 +17,10 @@ along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
 
 #include <amiroos.h>
+#include <ut_alld_LED_v1.h>
 
 #if ((AMIROOS_CFG_TESTS_ENABLE == true) && defined(AMIROLLD_CFG_LED) && (AMIROLLD_CFG_LED == 1)) || defined(__DOXYGEN__)
 
-#include <ut_alld_LED_v1.h>
-
 /******************************************************************************/
 /* LOCAL DEFINITIONS                                                          */
 /******************************************************************************/
diff --git a/unittests/periphery-lld/src/ut_alld_LIS331DLH_v1.c b/unittests/periphery-lld/src/ut_alld_LIS331DLH_v1.c
index 78a6c4d..ab25b91 100644
--- a/unittests/periphery-lld/src/ut_alld_LIS331DLH_v1.c
+++ b/unittests/periphery-lld/src/ut_alld_LIS331DLH_v1.c
@@ -17,11 +17,10 @@ along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
 
 #include <amiroos.h>
+#include <ut_alld_LIS331DLH_v1.h>
 
 #if ((AMIROOS_CFG_TESTS_ENABLE == true) && defined(AMIROLLD_CFG_LIS331DLH) && (AMIROLLD_CFG_LIS331DLH == 1)) || defined(__DOXYGEN__)
 
-#include <ut_alld_LIS331DLH_v1.h>
-
 /******************************************************************************/
 /* LOCAL DEFINITIONS                                                          */
 /******************************************************************************/
diff --git a/unittests/periphery-lld/src/ut_alld_LTC4412_v1.c b/unittests/periphery-lld/src/ut_alld_LTC4412_v1.c
index e6236ae..2158c15 100644
--- a/unittests/periphery-lld/src/ut_alld_LTC4412_v1.c
+++ b/unittests/periphery-lld/src/ut_alld_LTC4412_v1.c
@@ -17,11 +17,10 @@ along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
 
 #include <amiroos.h>
+#include <ut_alld_LTC4412_v1.h>
 
 #if ((AMIROOS_CFG_TESTS_ENABLE == true) && defined(AMIROLLD_CFG_LTC4412) && (AMIROLLD_CFG_LTC4412 == 1)) || defined(__DOXYGEN__)
 
-#include <ut_alld_LTC4412_v1.h>
-
 /******************************************************************************/
 /* LOCAL DEFINITIONS                                                          */
 /******************************************************************************/
diff --git a/unittests/periphery-lld/src/ut_alld_MPR121_v1.c b/unittests/periphery-lld/src/ut_alld_MPR121_v1.c
index 0cd380c..adfe2fc 100644
--- a/unittests/periphery-lld/src/ut_alld_MPR121_v1.c
+++ b/unittests/periphery-lld/src/ut_alld_MPR121_v1.c
@@ -17,11 +17,10 @@ along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
 
 #include <amiroos.h>
+#include <ut_alld_MPR121_v1.h>
 
 #if ((AMIROOS_CFG_TESTS_ENABLE == true) && defined(AMIROLLD_CFG_MPR121) && (AMIROLLD_CFG_MPR121 == 1)) || defined(__DOXYGEN__)
 
-#include <ut_alld_MPR121_v1.h>
-
 /******************************************************************************/
 /* LOCAL DEFINITIONS                                                          */
 /******************************************************************************/
diff --git a/unittests/periphery-lld/src/ut_alld_MPU6050_v1.c b/unittests/periphery-lld/src/ut_alld_MPU6050_v1.c
index 5ebff21..d21531d 100644
--- a/unittests/periphery-lld/src/ut_alld_MPU6050_v1.c
+++ b/unittests/periphery-lld/src/ut_alld_MPU6050_v1.c
@@ -17,11 +17,10 @@ along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
 
 #include <amiroos.h>
+#include <ut_alld_MPU6050_v1.h>
 
 #if ((AMIROOS_CFG_TESTS_ENABLE == true) && defined(AMIROLLD_CFG_MPU6050) && (AMIROLLD_CFG_MPU6050 == 1)) || defined(__DOXYGEN__)
 
-#include <ut_alld_MPU6050_v1.h>
-
 /******************************************************************************/
 /* LOCAL DEFINITIONS                                                          */
 /******************************************************************************/
diff --git a/unittests/periphery-lld/src/ut_alld_PCA9544A_v1.c b/unittests/periphery-lld/src/ut_alld_PCA9544A_v1.c
index dfa4a09..e28ca10 100644
--- a/unittests/periphery-lld/src/ut_alld_PCA9544A_v1.c
+++ b/unittests/periphery-lld/src/ut_alld_PCA9544A_v1.c
@@ -17,11 +17,10 @@ along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
 
 #include <amiroos.h>
+#include <ut_alld_PCA9544A_v1.h>
 
 #if ((AMIROOS_CFG_TESTS_ENABLE == true) && defined(AMIROLLD_CFG_PCA9544A) && (AMIROLLD_CFG_PCA9544A == 1)) || defined(__DOXYGEN__)
 
-#include <ut_alld_PCA9544A_v1.h>
-
 /******************************************************************************/
 /* LOCAL DEFINITIONS                                                          */
 /******************************************************************************/
diff --git a/unittests/periphery-lld/src/ut_alld_PCAL6524_v1.c b/unittests/periphery-lld/src/ut_alld_PCAL6524_v1.c
index e4fda2e..d85aecb 100644
--- a/unittests/periphery-lld/src/ut_alld_PCAL6524_v1.c
+++ b/unittests/periphery-lld/src/ut_alld_PCAL6524_v1.c
@@ -17,10 +17,10 @@ along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
 
 #include <amiroos.h>
+#include <ut_alld_PCAL6524_v1.h>
 
 #if ((AMIROOS_CFG_TESTS_ENABLE == true) && defined(AMIROLLD_CFG_PCAL6524) && (AMIROLLD_CFG_PCAL6524 == 1)) || defined(__DOXYGEN__)
 
-#include <ut_alld_PCAL6524_v1.h>
 #include <string.h>
 
 /******************************************************************************/
diff --git a/unittests/periphery-lld/src/ut_alld_PKxxxExxx_v1.c b/unittests/periphery-lld/src/ut_alld_PKxxxExxx_v1.c
index e304403..be29dc4 100644
--- a/unittests/periphery-lld/src/ut_alld_PKxxxExxx_v1.c
+++ b/unittests/periphery-lld/src/ut_alld_PKxxxExxx_v1.c
@@ -17,11 +17,10 @@ along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
 
 #include <amiroos.h>
+#include <ut_alld_PKxxxExxx_v1.h>
 
 #if ((AMIROOS_CFG_TESTS_ENABLE == true) && defined(AMIROLLD_CFG_PKxxxExxx) && (AMIROLLD_CFG_PKxxxExxx == 1)) || defined(__DOXYGEN__)
 
-#include <ut_alld_PKxxxExxx_v1.h>
-
 /******************************************************************************/
 /* LOCAL DEFINITIONS                                                          */
 /******************************************************************************/
diff --git a/unittests/periphery-lld/src/ut_alld_TLC5947_v1.c b/unittests/periphery-lld/src/ut_alld_TLC5947_v1.c
index a57a41c..204bbe9 100644
--- a/unittests/periphery-lld/src/ut_alld_TLC5947_v1.c
+++ b/unittests/periphery-lld/src/ut_alld_TLC5947_v1.c
@@ -17,10 +17,10 @@ along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
 
 #include <amiroos.h>
+#include <ut_alld_TLC5947_v1.h>
 
 #if ((AMIROOS_CFG_TESTS_ENABLE == true) && defined(AMIROLLD_CFG_TLC5947) && (AMIROLLD_CFG_TLC5947 == 1)) || defined(__DOXYGEN__)
 
-#include <ut_alld_TLC5947_v1.h>
 #include <string.h>
 
 /******************************************************************************/
diff --git a/unittests/periphery-lld/src/ut_alld_TPS20xxB_v1.c b/unittests/periphery-lld/src/ut_alld_TPS20xxB_v1.c
index 7911e4e..8538469 100644
--- a/unittests/periphery-lld/src/ut_alld_TPS20xxB_v1.c
+++ b/unittests/periphery-lld/src/ut_alld_TPS20xxB_v1.c
@@ -17,11 +17,10 @@ along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
 
 #include <amiroos.h>
+#include <ut_alld_TPS20xxB_v1.h>
 
 #if ((AMIROOS_CFG_TESTS_ENABLE == true) && defined(AMIROLLD_CFG_TPS20xxB) && (AMIROLLD_CFG_TPS20xxB == 1)) || defined(__DOXYGEN__)
 
-#include <ut_alld_TPS20xxB_v1.h>
-
 /******************************************************************************/
 /* LOCAL DEFINITIONS                                                          */
 /******************************************************************************/
diff --git a/unittests/periphery-lld/src/ut_alld_TPS6211x_v1.c b/unittests/periphery-lld/src/ut_alld_TPS6211x_v1.c
index b44c50b..063d2cc 100644
--- a/unittests/periphery-lld/src/ut_alld_TPS6211x_v1.c
+++ b/unittests/periphery-lld/src/ut_alld_TPS6211x_v1.c
@@ -17,11 +17,10 @@ along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
 
 #include <amiroos.h>
+#include <ut_alld_TPS6211x_v1.h>
 
 #if ((AMIROOS_CFG_TESTS_ENABLE == true) && defined(AMIROLLD_CFG_TPS6211x) && (AMIROLLD_CFG_TPS6211x == 1)) || defined(__DOXYGEN__)
 
-#include <ut_alld_TPS6211x_v1.h>
-
 /******************************************************************************/
 /* LOCAL DEFINITIONS                                                          */
 /******************************************************************************/
diff --git a/unittests/periphery-lld/src/ut_alld_TPS6211x_v1_INA219_v1.c b/unittests/periphery-lld/src/ut_alld_TPS6211x_v1_INA219_v1.c
index c2c6d23..2aa159b 100644
--- a/unittests/periphery-lld/src/ut_alld_TPS6211x_v1_INA219_v1.c
+++ b/unittests/periphery-lld/src/ut_alld_TPS6211x_v1_INA219_v1.c
@@ -17,11 +17,10 @@ along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
 
 #include <amiroos.h>
+#include <ut_alld_TPS6211x_v1_INA219_v1.h>
 
 #if ((AMIROOS_CFG_TESTS_ENABLE == true) && defined(AMIROLLD_CFG_TPS6211x) && (AMIROLLD_CFG_TPS6211x == 1) && defined(AMIROLLD_CFG_INA219) && (AMIROLLD_CFG_INA219 == 1)) || defined(__DOXYGEN__)
 
-#include <ut_alld_TPS6211x_v1_INA219_v1.h>
-
 /******************************************************************************/
 /* LOCAL DEFINITIONS                                                          */
 /******************************************************************************/
diff --git a/unittests/periphery-lld/src/ut_alld_VCNL4020_v1.c b/unittests/periphery-lld/src/ut_alld_VCNL4020_v1.c
index bb70a03..198b642 100644
--- a/unittests/periphery-lld/src/ut_alld_VCNL4020_v1.c
+++ b/unittests/periphery-lld/src/ut_alld_VCNL4020_v1.c
@@ -17,11 +17,10 @@ along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
 
 #include <amiroos.h>
+#include <ut_alld_VCNL4020_v1.h>
 
 #if ((AMIROOS_CFG_TESTS_ENABLE == true) && defined(AMIROLLD_CFG_VCNL4020) && (AMIROLLD_CFG_VCNL4020 == 1)) || defined(__DOXYGEN__)
 
-#include <ut_alld_VCNL4020_v1.h>
-
 /******************************************************************************/
 /* LOCAL DEFINITIONS                                                          */
 /******************************************************************************/
diff --git a/unittests/periphery-lld/src/ut_alld_bq241xx_v1.c b/unittests/periphery-lld/src/ut_alld_bq241xx_v1.c
index de4ca1b..200b2c4 100644
--- a/unittests/periphery-lld/src/ut_alld_bq241xx_v1.c
+++ b/unittests/periphery-lld/src/ut_alld_bq241xx_v1.c
@@ -17,11 +17,10 @@ along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
 
 #include <amiroos.h>
+#include <ut_alld_bq241xx_v1.h>
 
 #if ((AMIROOS_CFG_TESTS_ENABLE == true) && defined(AMIROLLD_CFG_BQ241xx) && (AMIROLLD_CFG_BQ241xx == 1)) || defined(__DOXYGEN__)
 
-#include <ut_alld_bq241xx_v1.h>
-
 /******************************************************************************/
 /* LOCAL DEFINITIONS                                                          */
 /******************************************************************************/
diff --git a/unittests/periphery-lld/src/ut_alld_bq27500_v1.c b/unittests/periphery-lld/src/ut_alld_bq27500_v1.c
index 662b3bd..73b0f59 100644
--- a/unittests/periphery-lld/src/ut_alld_bq27500_v1.c
+++ b/unittests/periphery-lld/src/ut_alld_bq27500_v1.c
@@ -17,10 +17,10 @@ along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
 
 #include <amiroos.h>
+#include <ut_alld_bq27500_v1.h>
 
 #if ((AMIROOS_CFG_TESTS_ENABLE == true) && defined(AMIROLLD_CFG_BQ27500) && (AMIROLLD_CFG_BQ27500 == 1)) || defined(__DOXYGEN__)
 
-#include <ut_alld_bq27500_v1.h>
 #include <string.h>
 
 /******************************************************************************/
diff --git a/unittests/periphery-lld/src/ut_alld_bq27500_v1_bq241xx_v1.c b/unittests/periphery-lld/src/ut_alld_bq27500_v1_bq241xx_v1.c
index dd703eb..dfc1172 100644
--- a/unittests/periphery-lld/src/ut_alld_bq27500_v1_bq241xx_v1.c
+++ b/unittests/periphery-lld/src/ut_alld_bq27500_v1_bq241xx_v1.c
@@ -17,11 +17,10 @@ along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
 
 #include <amiroos.h>
+#include <ut_alld_bq27500_v1_bq241xx_v1.h>
 
 #if ((AMIROOS_CFG_TESTS_ENABLE == true) && defined(AMIROLLD_CFG_BQ27500) && (AMIROLLD_CFG_BQ27500 == 1) && defined(AMIROLLD_CFG_BQ241xx) && (AMIROLLD_CFG_BQ241xx == 1)) || defined(__DOXYGEN__)
 
-#include <ut_alld_bq27500_v1_bq241xx_v1.h>
-
 /******************************************************************************/
 /* LOCAL DEFINITIONS                                                          */
 /******************************************************************************/