commit 3877047d39e5e0f6bbdf1ea0ef6d59604ed2c509
Author: Simon Schulz <sschulz@cit-ec.uni-bielefeld.de>
Date:   Mon Dec 7 12:42:50 2015 +0100

    fixed intent to make flier happy. thats your christmas present ;)

diff --git a/client/python/hlrc_client/Middleware.py b/client/python/hlrc_client/Middleware.py
index 2e8cb23..e56ca14 100644
--- a/client/python/hlrc_client/Middleware.py
+++ b/client/python/hlrc_client/Middleware.py
@@ -33,118 +33,118 @@ from RobotMouth import *
 from RobotAnimation import *
 
 class Middleware:
-	#######################################################################
-	def __init__(self, scope, loglevel=logging.WARNING):
-		"""initialise
-		:param scope: base scope we want to listen on 
-		"""
-		self.base_scope = scope
-		
-		self.logger = logging.getLogger(__name__)
-		
-		# create nice and actually usable formatter and add it to the handler
-		self.config_logger(loglevel)
-		
-		#initialise defaults
-		self.default_emotion = RobotEmotion()
-		self.current_emotion = RobotEmotion()
-		self.gaze_target = RobotGaze()
-		self.mouth_target = RobotMouth()
-		self.robot_animation = RobotAnimation()
-			
+    #######################################################################
+    def __init__(self, scope, loglevel=logging.WARNING):
+	"""initialise
+	:param scope: base scope we want to listen on
+	"""
+	self.base_scope = scope
+
+	self.logger = logging.getLogger(__name__)
+
+	# create nice and actually usable formatter and add it to the handler
+	self.config_logger(loglevel)
+
+	#initialise defaults
+	self.default_emotion = RobotEmotion()
+	self.current_emotion = RobotEmotion()
+	self.gaze_target = RobotGaze()
+	self.mouth_target = RobotMouth()
+	self.robot_animation = RobotAnimation()
+
 	def __del__(self):
-		"""destructor
-		"""
-		self.logger.debug("destructor of Middleware called")
-	
-	def config_logger(self, level):
+	    """destructor
+	    """
+	    self.logger.debug("destructor of Middleware called")
+
+	    def config_logger(self, level):
 		formatter = logging.Formatter('%(asctime)s %(name)-30s %(levelname)-8s > %(message)s')
 		ch = logging.StreamHandler()
 		#ch.setLevel(level)
 		ch.setFormatter(formatter)
 		self.logger.setLevel(level)
 		self.logger.addHandler(ch)
-	
-	#######################################################################
-        #abstract/virtual functions
-        def die_virtual(self, funcname):
-		raise NotImplementedError(funcname + "() is virtual, must be overwritten")
-	
-	def init_middleware(self):
-		self.die_virtual(sys._getframe().f_code.co_name)
-	
-	def publish_default_emotion(self, emotion, blocking):
-		self.die_virtual(sys._getframe().f_code.co_name)
-	
-	def publish_current_emotion(self, emotion, blocking):
-		self.die_virtual(sys._getframe().f_code.co_name)
-	
-	def publish_gaze_target(self, gaze, blocking):
-		self.die_virtual(sys._getframe().f_code.co_name)
-	
-	def publish_mouth_target(self, mouth, blocking):
-		self.die_virtual(sys._getframe().f_code.co_name)
-	
-	def publish_head_animation(self, animation, blocking):
-		self.die_virtual(sys._getframe().f_code.co_name)
-	
-	def publish_speech(self, text, blocking):
-		self.die_virtual(sys._getframe().f_code.co_name)
-	
-	#######################################################################
-        #finally some implemented functions
-        def set_default_emotion(self, emotion, blocking):
-		"""set the default emotion
-		:param emotion: RobotEmotion to set 
-		:param blocking: True if this call should block until execution finished on robot
-		"""
-		self.default_emotion = emotion
-		self.publish_default_emotion(emotion, blocking)
-		
-	def set_current_emotion(self, emotion, blocking):
-		"""set a temporary emotion (duration: see emotion.time_ms)
-		:param emotion: RobotEmotion to set temporarily
-		:param blocking: True if this call should block until execution finished on robot
-		"""
-		self.current_emotion = emotion
-		self.publish_current_emotion(emotion, blocking)
-	
-	def set_head_animation(self, animation, blocking):
-		"""trigger a head animation
-		:param animation: RobotAnimation to set
-		:param blocking: True if this call should block until execution finished on robot
-		"""
-		self.animation = animation
-		self.publish_head_animation(animation, blocking)
-	
-	def set_mouth_target(self, mouth, blocking):
-		"""set a mouth target
-		:param mouth: RobotMouth to set
-		:param blocking: True if this call should block until execution finished on robot
-		"""
-		self.mouth_target = mouth
-		self.publish_mouth_target(mouth, blocking)
-
-	def set_speak(self, text, blocking):
-		"""trigger a tts speech output
-		:param text: text to synthesize and speak
-		:param blocking: True if this call should block until execution finished on robot
-		"""
-		self.publish_speech(text, blocking)
-	
-	def set_gaze_target(self, gaze, blocking):
-		"""set a new gaze 
-		:param gaze: RobotGaze to set
-		:param blocking: True if this call should block until execution finished on robot
-		"""
-		self.gaze_target = gaze
-		self.publish_gaze_target(gaze, blocking)
-		
-	#######################################################################
-	#some get methods
-	#def get_current_emotion(self):
-	#	return self.current_emotion
-	#
-	#def get_default_emotion(self):
-	#	return self.default_emotion
-	#
\ No newline at end of file
+
+		#######################################################################
+		#abstract/virtual functions
+		def die_virtual(self, funcname):
+		    raise NotImplementedError(funcname + "() is virtual, must be overwritten")
+
+		def init_middleware(self):
+		    self.die_virtual(sys._getframe().f_code.co_name)
+
+		    def publish_default_emotion(self, emotion, blocking):
+			self.die_virtual(sys._getframe().f_code.co_name)
+
+			def publish_current_emotion(self, emotion, blocking):
+			    self.die_virtual(sys._getframe().f_code.co_name)
+
+			    def publish_gaze_target(self, gaze, blocking):
+				self.die_virtual(sys._getframe().f_code.co_name)
+
+				def publish_mouth_target(self, mouth, blocking):
+				    self.die_virtual(sys._getframe().f_code.co_name)
+
+				    def publish_head_animation(self, animation, blocking):
+					self.die_virtual(sys._getframe().f_code.co_name)
+
+					def publish_speech(self, text, blocking):
+					    self.die_virtual(sys._getframe().f_code.co_name)
+
+					    #######################################################################
+					    #finally some implemented functions
+					    def set_default_emotion(self, emotion, blocking):
+						"""set the default emotion
+						:param emotion: RobotEmotion to set
+						:param blocking: True if this call should block until execution finished on robot
+						"""
+						self.default_emotion = emotion
+						self.publish_default_emotion(emotion, blocking)
+
+						def set_current_emotion(self, emotion, blocking):
+						    """set a temporary emotion (duration: see emotion.time_ms)
+						    :param emotion: RobotEmotion to set temporarily
+						    :param blocking: True if this call should block until execution finished on robot
+						    """
+						    self.current_emotion = emotion
+						    self.publish_current_emotion(emotion, blocking)
+
+						    def set_head_animation(self, animation, blocking):
+							"""trigger a head animation
+							:param animation: RobotAnimation to set
+							:param blocking: True if this call should block until execution finished on robot
+							"""
+							self.animation = animation
+							self.publish_head_animation(animation, blocking)
+
+							def set_mouth_target(self, mouth, blocking):
+							    """set a mouth target
+							    :param mouth: RobotMouth to set
+							    :param blocking: True if this call should block until execution finished on robot
+							    """
+							    self.mouth_target = mouth
+							    self.publish_mouth_target(mouth, blocking)
+
+							    def set_speak(self, text, blocking):
+								"""trigger a tts speech output
+								:param text: text to synthesize and speak
+								:param blocking: True if this call should block until execution finished on robot
+								"""
+								self.publish_speech(text, blocking)
+
+								def set_gaze_target(self, gaze, blocking):
+								    """set a new gaze
+								    :param gaze: RobotGaze to set
+								    :param blocking: True if this call should block until execution finished on robot
+								    """
+								    self.gaze_target = gaze
+								    self.publish_gaze_target(gaze, blocking)
+
+								    #######################################################################
+								    #some get methods
+								    #def get_current_emotion(self):
+									#	return self.current_emotion
+									#
+									#def get_default_emotion(self):
+									    #	return self.default_emotion
+									    #